/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the IdIntTrait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IdIntTrait{}

// IdIntTrait struct for IdIntTrait
type IdIntTrait struct {
	Id NullableInt32 `json:"id,omitempty"`
}

// NewIdIntTrait instantiates a new IdIntTrait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdIntTrait() *IdIntTrait {
	this := IdIntTrait{}
	return &this
}

// NewIdIntTraitWithDefaults instantiates a new IdIntTrait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdIntTraitWithDefaults() *IdIntTrait {
	this := IdIntTrait{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdIntTrait) GetId() int32 {
	if o == nil || IsNil(o.Id.Get()) {
		var ret int32
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdIntTrait) GetIdOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *IdIntTrait) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableInt32 and assigns it to the Id field.
func (o *IdIntTrait) SetId(v int32) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *IdIntTrait) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *IdIntTrait) UnsetId() {
	o.Id.Unset()
}

func (o IdIntTrait) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IdIntTrait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	return toSerialize, nil
}

type NullableIdIntTrait struct {
	value *IdIntTrait
	isSet bool
}

func (v NullableIdIntTrait) Get() *IdIntTrait {
	return v.value
}

func (v *NullableIdIntTrait) Set(val *IdIntTrait) {
	v.value = val
	v.isSet = true
}

func (v NullableIdIntTrait) IsSet() bool {
	return v.isSet
}

func (v *NullableIdIntTrait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdIntTrait(val *IdIntTrait) *NullableIdIntTrait {
	return &NullableIdIntTrait{value: val, isSet: true}
}

func (v NullableIdIntTrait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdIntTrait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
